package de.cau.cs.kieler.kgraph.text.formatting;

import com.google.inject.Inject;
import de.cau.cs.kieler.kgraph.text.services.GRandomGrammarAccess;
import java.util.List;
import org.eclipse.xtext.EnumRule;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;
import org.eclipse.xtext.util.Pair;
import org.eclipse.xtext.xbase.lib.Extension;

@SuppressWarnings("all")
public class GRandomFormatter extends AbstractDeclarativeFormatter {
  @Inject
  @Extension
  private GRandomGrammarAccess _gRandomGrammarAccess;
  
  @Override
  protected void configureFormatting(final FormattingConfig c) {
    c.setAutoLinewrap(120);
    FormattingConfig.LinewrapLocator _setLinewrap = c.setLinewrap(0, 1, 2);
    TerminalRule _sL_COMMENTRule = this._gRandomGrammarAccess.getSL_COMMENTRule();
    _setLinewrap.before(_sL_COMMENTRule);
    FormattingConfig.LinewrapLocator _setLinewrap_1 = c.setLinewrap(0, 1, 2);
    TerminalRule _mL_COMMENTRule = this._gRandomGrammarAccess.getML_COMMENTRule();
    _setLinewrap_1.before(_mL_COMMENTRule);
    FormattingConfig.LinewrapLocator _setLinewrap_2 = c.setLinewrap(0, 1, 1);
    TerminalRule _mL_COMMENTRule_1 = this._gRandomGrammarAccess.getML_COMMENTRule();
    _setLinewrap_2.after(_mL_COMMENTRule_1);
    List<Pair<Keyword, Keyword>> _findKeywordPairs = this._gRandomGrammarAccess.findKeywordPairs("{", "}");
    for (final Pair<Keyword, Keyword> pair : _findKeywordPairs) {
      {
        Keyword _first = pair.getFirst();
        Keyword _second = pair.getSecond();
        c.setIndentation(_first, _second);
        FormattingConfig.NoLinewrapLocator _setNoLinewrap = c.setNoLinewrap();
        Keyword _first_1 = pair.getFirst();
        _setNoLinewrap.before(_first_1);
        FormattingConfig.LinewrapLocator _setLinewrap_3 = c.setLinewrap();
        Keyword _first_2 = pair.getFirst();
        _setLinewrap_3.after(_first_2);
        FormattingConfig.LinewrapLocator _setLinewrap_4 = c.setLinewrap();
        Keyword _second_1 = pair.getSecond();
        _setLinewrap_4.after(_second_1);
      }
    }
    List<Keyword> _findKeywords = this._gRandomGrammarAccess.findKeywords("=");
    for (final Keyword equals : _findKeywords) {
      FormattingConfig.NoLinewrapLocator _setNoLinewrap = c.setNoLinewrap();
      _setNoLinewrap.before(equals);
    }
    FormattingConfig.LinewrapLocator _setLinewrap_3 = c.setLinewrap();
    ParserRule _doubleQuantityRule = this._gRandomGrammarAccess.getDoubleQuantityRule();
    _setLinewrap_3.after(_doubleQuantityRule);
    FormattingConfig.LinewrapLocator _setLinewrap_4 = c.setLinewrap();
    ParserRule _labelsRule = this._gRandomGrammarAccess.getLabelsRule();
    _setLinewrap_4.after(_labelsRule);
    FormattingConfig.LinewrapLocator _setLinewrap_5 = c.setLinewrap();
    ParserRule _integerRule = this._gRandomGrammarAccess.getIntegerRule();
    _setLinewrap_5.after(_integerRule);
    FormattingConfig.LinewrapLocator _setLinewrap_6 = c.setLinewrap();
    TerminalRule _sTRINGRule = this._gRandomGrammarAccess.getSTRINGRule();
    _setLinewrap_6.after(_sTRINGRule);
    FormattingConfig.LinewrapLocator _setLinewrap_7 = c.setLinewrap();
    EnumRule _formatsRule = this._gRandomGrammarAccess.getFormatsRule();
    _setLinewrap_7.after(_formatsRule);
    FormattingConfig.LinewrapLocator _setLinewrap_8 = c.setLinewrap();
    ParserRule _floatRule = this._gRandomGrammarAccess.getFloatRule();
    _setLinewrap_8.after(_floatRule);
    FormattingConfig.LinewrapLocator _setLinewrap_9 = c.setLinewrap();
    EnumRule _sideRule = this._gRandomGrammarAccess.getSideRule();
    _setLinewrap_9.after(_sideRule);
    FormattingConfig.LinewrapLocator _setLinewrap_10 = c.setLinewrap();
    EnumRule _constraintTypeRule = this._gRandomGrammarAccess.getConstraintTypeRule();
    _setLinewrap_10.after(_constraintTypeRule);
    FormattingConfig.LinewrapLocator _setLinewrap_11 = c.setLinewrap(2);
    ParserRule _configurationRule = this._gRandomGrammarAccess.getConfigurationRule();
    _setLinewrap_11.after(_configurationRule);
  }
}
