/**
 * KIELER - Kiel Integrated Environment for Layout Eclipse RichClient
 * 
 * http://rtsys.informatik.uni-kiel.de/kieler
 * 
 * Copyright 2016 by
 * + Kiel University
 *   + Department of Computer Science
 *     + Real-Time and Embedded Systems Group
 * 
 * This code is provided under the terms of the Eclipse Public License (EPL).
 */
package de.cau.cs.kieler.kgraph.text.ui.random;

import de.cau.cs.kieler.kgraph.text.grandom.RandGraph;
import de.cau.cs.kieler.kgraph.text.ui.random.GRandomGraphMaker;
import java.io.InputStream;
import java.util.Collections;
import java.util.Map;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.handlers.HandlerUtil;
import org.eclipse.ui.statushandlers.StatusManager;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

@SuppressWarnings("all")
public class GRandomHandler extends AbstractHandler {
  @Override
  public Object execute(final ExecutionEvent event) throws ExecutionException {
    IWorkbench _workbench = PlatformUI.getWorkbench();
    _workbench.saveAllEditors(true);
    final ISelection selection = HandlerUtil.getCurrentSelection(event);
    if ((selection instanceof IStructuredSelection)) {
      final Object element = ((IStructuredSelection) selection).getFirstElement();
      if ((element instanceof IFile)) {
        try {
          final ResourceSetImpl resourceSet = new ResourceSetImpl();
          URI _createFileURI = URI.createFileURI("dummy.rdg");
          final Resource r = resourceSet.createResource(_createFileURI);
          InputStream _contents = ((IFile) element).getContents();
          Map<Object, Object> _emptyMap = Collections.<Object, Object>emptyMap();
          r.load(_contents, _emptyMap);
          final IProject project = ((IFile)element).getProject();
          boolean _and = false;
          EList<EObject> _contents_1 = r.getContents();
          boolean _isEmpty = _contents_1.isEmpty();
          boolean _not = (!_isEmpty);
          if (!_not) {
            _and = false;
          } else {
            EList<EObject> _contents_2 = r.getContents();
            EObject _get = _contents_2.get(0);
            _and = (_get instanceof RandGraph);
          }
          if (_and) {
            EList<EObject> _contents_3 = r.getContents();
            EObject _head = IterableExtensions.<EObject>head(_contents_3);
            final RandGraph rand = ((RandGraph) _head);
            final Job job = new Job("Generate Random Graphs") {
              @Override
              protected IStatus run(final IProgressMonitor monitor) {
                monitor.beginTask("Generate Random Graphs", 1);
                try {
                  GRandomGraphMaker _gRandomGraphMaker = new GRandomGraphMaker(rand);
                  _gRandomGraphMaker.gen(project);
                } catch (final Throwable _t) {
                  if (_t instanceof Exception) {
                    final Exception e = (Exception)_t;
                    final Status status = new Status(IStatus.ERROR, "de.cau.cs.kiel.kgraph.randgraph", 0, 
                      "Random Graph Generation failed", e);
                    StatusManager _manager = StatusManager.getManager();
                    _manager.handle(status, 
                      (StatusManager.SHOW | StatusManager.LOG));
                  } else {
                    throw Exceptions.sneakyThrow(_t);
                  }
                } finally {
                  monitor.done();
                }
                return Status.OK_STATUS;
              }
            };
            job.setUser(true);
            job.schedule();
          }
        } catch (final Throwable _t) {
          if (_t instanceof Exception) {
            final Exception e = (Exception)_t;
          } else {
            throw Exceptions.sneakyThrow(_t);
          }
        }
      }
    }
    return null;
  }
}
