/**
 * generated by Xtext 2.9.2
 */
package de.cau.cs.kieler.kgraph.text.validation;

import com.google.common.base.Objects;
import de.cau.cs.kieler.kgraph.text.grandom.Configuration;
import de.cau.cs.kieler.kgraph.text.grandom.Form;
import de.cau.cs.kieler.kgraph.text.grandom.GrandomPackage;
import de.cau.cs.kieler.kgraph.text.validation.AbstractGRandomValidator;
import java.util.ArrayList;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.xtext.validation.Check;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.Pair;

/**
 * This class contains custom validation rules.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
@SuppressWarnings("all")
public class GRandomValidator extends AbstractGRandomValidator {
  public final static ArrayList<Pair<Function1<Configuration, Boolean>, Pair<String, EAttribute>>> errors = CollectionLiterals.<Pair<Function1<Configuration, Boolean>, Pair<String, EAttribute>>>newArrayList(
    Pair.<Function1<Configuration, Boolean>, Pair<String, EAttribute>>of(new Function1<Configuration, Boolean>() {
      @Override
      public Boolean apply(final Configuration c) {
        boolean _and = false;
        Form _form = c.getForm();
        boolean _notEquals = (!Objects.equal(_form, Form.TREES));
        if (!_notEquals) {
          _and = false;
        } else {
          boolean _isMD = c.isMD();
          _and = _isMD;
        }
        return Boolean.valueOf(_and);
      }
    }, 
      Pair.<String, EAttribute>of("maxDegree only defined on trees.", GrandomPackage.Literals.CONFIGURATION__MD)), 
    Pair.<Function1<Configuration, Boolean>, Pair<String, EAttribute>>of(new Function1<Configuration, Boolean>() {
      @Override
      public Boolean apply(final Configuration c) {
        boolean _and = false;
        Form _form = c.getForm();
        boolean _notEquals = (!Objects.equal(_form, Form.TREES));
        if (!_notEquals) {
          _and = false;
        } else {
          boolean _isMW = c.isMW();
          _and = _isMW;
        }
        return Boolean.valueOf(_and);
      }
    }, 
      Pair.<String, EAttribute>of("maxWidth only defined on trees.", GrandomPackage.Literals.CONFIGURATION__MW)), 
    Pair.<Function1<Configuration, Boolean>, Pair<String, EAttribute>>of(new Function1<Configuration, Boolean>() {
      @Override
      public Boolean apply(final Configuration c) {
        boolean _and = false;
        Form _form = c.getForm();
        boolean _notEquals = (!Objects.equal(_form, Form.BIPARTITE));
        if (!_notEquals) {
          _and = false;
        } else {
          boolean _isPF = c.isPF();
          _and = _isPF;
        }
        return Boolean.valueOf(_and);
      }
    }, 
      Pair.<String, EAttribute>of("Partition Fraction only defined on bipartite graphs.", 
        GrandomPackage.Literals.CONFIGURATION__PF)));
  
  @Check
  public void optionsRestrictions(final Configuration conf) {
    for (final Pair<Function1<Configuration, Boolean>, Pair<String, EAttribute>> p : GRandomValidator.errors) {
      Function1<Configuration, Boolean> _key = p.getKey();
      Boolean _apply = _key.apply(conf);
      if ((_apply).booleanValue()) {
        Pair<String, EAttribute> _value = p.getValue();
        String _key_1 = _value.getKey();
        Pair<String, EAttribute> _value_1 = p.getValue();
        EAttribute _value_2 = _value_1.getValue();
        this.error(_key_1, _value_2);
      }
    }
  }
}
