/**
 * KIELER - Kiel Integrated Environment for Layout Eclipse RichClient
 * 
 * http://www.informatik.uni-kiel.de/rtsys/kieler/
 * 
 * Copyright 2013 by
 * + Kiel University
 *   + Department of Computer Science
 *     + Real-Time and Embedded Systems Group
 * 
 * This code is provided under the terms of the Eclipse Public License (EPL).
 * See the file epl-v10.html for the license text.
 */
package de.cau.cs.kieler.kiml.formats.json;

import com.google.common.base.Objects;
import com.google.common.collect.Iterators;
import java.util.Iterator;
import org.eclipse.elk.core.klayoutdata.KEdgeLayout;
import org.eclipse.elk.core.klayoutdata.KShapeLayout;
import org.eclipse.elk.graph.KEdge;
import org.eclipse.elk.graph.KLabel;
import org.eclipse.elk.graph.KNode;
import org.eclipse.elk.graph.KPort;

/**
 * Some convenience.
 * 
 * @author uru
 */
@SuppressWarnings("all")
public class JsonExtensions {
  public KShapeLayout layout(final KNode node) {
    return node.<KShapeLayout>getData(KShapeLayout.class);
  }
  
  public KShapeLayout layout(final KPort port) {
    return port.<KShapeLayout>getData(KShapeLayout.class);
  }
  
  public KShapeLayout layout(final KLabel label) {
    return label.<KShapeLayout>getData(KShapeLayout.class);
  }
  
  public KEdgeLayout layout(final KEdge edge) {
    return edge.<KEdgeLayout>getData(KEdgeLayout.class);
  }
  
  /**
   * Maps infinite or NaN values to 0f.
   */
  public float floatValueValid(final Double d) {
    boolean _or = false;
    boolean _or_1 = false;
    boolean _equals = Objects.equal(d, null);
    if (_equals) {
      _or_1 = true;
    } else {
      boolean _isInfinite = d.isInfinite();
      _or_1 = _isInfinite;
    }
    if (_or_1) {
      _or = true;
    } else {
      boolean _isNaN = d.isNaN();
      _or = _isNaN;
    }
    if (_or) {
      return 0f;
    } else {
      return d.floatValue();
    }
  }
  
  public <T extends Object> Iterator<T> emptyIfNull(final Iterator<T> iterator) {
    Iterator<T> _xifexpression = null;
    boolean _equals = Objects.equal(iterator, null);
    if (_equals) {
      return Iterators.<T>emptyIterator();
    } else {
      _xifexpression = iterator;
    }
    return _xifexpression;
  }
}
