/*
 * generated by Xtext
 */
package de.cau.cs.kieler.kiml.grana.text.serializer;

import com.google.inject.Inject;
import de.cau.cs.kieler.kiml.grana.text.grana.Analysis;
import de.cau.cs.kieler.kiml.grana.text.grana.FloatRange;
import de.cau.cs.kieler.kiml.grana.text.grana.GlobalOutputRef;
import de.cau.cs.kieler.kiml.grana.text.grana.GlobalResourceRef;
import de.cau.cs.kieler.kiml.grana.text.grana.Grana;
import de.cau.cs.kieler.kiml.grana.text.grana.GranaPackage;
import de.cau.cs.kieler.kiml.grana.text.grana.IntRangeRange;
import de.cau.cs.kieler.kiml.grana.text.grana.IntRangeValues;
import de.cau.cs.kieler.kiml.grana.text.grana.LocalOutput;
import de.cau.cs.kieler.kiml.grana.text.grana.LocalResource;
import de.cau.cs.kieler.kiml.grana.text.grana.OutputReference;
import de.cau.cs.kieler.kiml.grana.text.grana.RangeJob;
import de.cau.cs.kieler.kiml.grana.text.grana.RegularJob;
import de.cau.cs.kieler.kiml.grana.text.grana.ResourceReference;
import de.cau.cs.kieler.kiml.grana.text.services.GranaGrammarAccess;
import java.util.Set;
import org.eclipse.elk.core.klayoutdata.KIdentifier;
import org.eclipse.elk.core.klayoutdata.KLayoutDataPackage;
import org.eclipse.elk.graph.KGraphPackage;
import org.eclipse.elk.graph.PersistentEntry;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public class GranaSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private GranaGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == GranaPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case GranaPackage.ANALYSIS:
				sequence_Analysis(context, (Analysis) semanticObject); 
				return; 
			case GranaPackage.FLOAT_RANGE:
				sequence_FloatRange(context, (FloatRange) semanticObject); 
				return; 
			case GranaPackage.GLOBAL_OUTPUT_REF:
				sequence_GlobalOutputRef(context, (GlobalOutputRef) semanticObject); 
				return; 
			case GranaPackage.GLOBAL_RESOURCE_REF:
				sequence_GlobalResourceRef(context, (GlobalResourceRef) semanticObject); 
				return; 
			case GranaPackage.GRANA:
				sequence_Grana(context, (Grana) semanticObject); 
				return; 
			case GranaPackage.INT_RANGE_RANGE:
				sequence_IntRangeRange(context, (IntRangeRange) semanticObject); 
				return; 
			case GranaPackage.INT_RANGE_VALUES:
				sequence_IntRangeValues(context, (IntRangeValues) semanticObject); 
				return; 
			case GranaPackage.LOCAL_OUTPUT:
				sequence_LocalOutput(context, (LocalOutput) semanticObject); 
				return; 
			case GranaPackage.LOCAL_RESOURCE:
				sequence_LocalResource(context, (LocalResource) semanticObject); 
				return; 
			case GranaPackage.OUTPUT_REFERENCE:
				sequence_OutputReference(context, (OutputReference) semanticObject); 
				return; 
			case GranaPackage.RANGE_JOB:
				sequence_RangeJob(context, (RangeJob) semanticObject); 
				return; 
			case GranaPackage.REGULAR_JOB:
				sequence_RegularJob(context, (RegularJob) semanticObject); 
				return; 
			case GranaPackage.RESOURCE_REFERENCE:
				sequence_ResourceReference(context, (ResourceReference) semanticObject); 
				return; 
			}
		else if (epackage == KGraphPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case KGraphPackage.PERSISTENT_ENTRY:
				sequence_PersistentEntry(context, (PersistentEntry) semanticObject); 
				return; 
			}
		else if (epackage == KLayoutDataPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case KLayoutDataPackage.KIDENTIFIER:
				sequence_KIdentifier(context, (KIdentifier) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Analysis returns Analysis
	 *
	 * Constraint:
	 *     name=QualifiedID
	 */
	protected void sequence_Analysis(ISerializationContext context, Analysis semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.ANALYSIS__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.ANALYSIS__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getAnalysisAccess().getNameQualifiedIDParserRuleCall_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Range returns FloatRange
	 *     FloatRange returns FloatRange
	 *
	 * Constraint:
	 *     (values+=Float values+=Float*)
	 */
	protected void sequence_FloatRange(ISerializationContext context, FloatRange semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     GlobalOutputRef returns GlobalOutputRef
	 *
	 * Constraint:
	 *     (name=ID output=LocalOutput)
	 */
	protected void sequence_GlobalOutputRef(ISerializationContext context, GlobalOutputRef semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.GLOBAL_OUTPUT_REF__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.GLOBAL_OUTPUT_REF__NAME));
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.GLOBAL_OUTPUT_REF__OUTPUT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.GLOBAL_OUTPUT_REF__OUTPUT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getGlobalOutputRefAccess().getNameIDTerminalRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getGlobalOutputRefAccess().getOutputLocalOutputParserRuleCall_1_0(), semanticObject.getOutput());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     GlobalResourceRef returns GlobalResourceRef
	 *
	 * Constraint:
	 *     (name=ID resources+=LocalResource)
	 */
	protected void sequence_GlobalResourceRef(ISerializationContext context, GlobalResourceRef semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Grana returns Grana
	 *
	 * Constraint:
	 *     (globalResources+=GlobalResourceRef* gloobalOutputs+=GlobalOutputRef* (executeAll?='all' | execute+=[Job|ID]+) jobs+=Job+)
	 */
	protected void sequence_Grana(ISerializationContext context, Grana semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Range returns IntRangeRange
	 *     IntRange returns IntRangeRange
	 *     IntRangeRange returns IntRangeRange
	 *
	 * Constraint:
	 *     (start=NATURAL end=NATURAL)
	 */
	protected void sequence_IntRangeRange(ISerializationContext context, IntRangeRange semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.INT_RANGE_RANGE__START) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.INT_RANGE_RANGE__START));
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.INT_RANGE_RANGE__END) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.INT_RANGE_RANGE__END));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getIntRangeRangeAccess().getStartNATURALTerminalRuleCall_1_0(), semanticObject.getStart());
		feeder.accept(grammarAccess.getIntRangeRangeAccess().getEndNATURALTerminalRuleCall_3_0(), semanticObject.getEnd());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Range returns IntRangeValues
	 *     IntRange returns IntRangeValues
	 *     IntRangeValues returns IntRangeValues
	 *
	 * Constraint:
	 *     (values+=NATURAL values+=NATURAL*)
	 */
	protected void sequence_IntRangeValues(ISerializationContext context, IntRangeValues semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     KIdentifier returns KIdentifier
	 *
	 * Constraint:
	 *     (id=ID (persistentEntries+=PersistentEntry persistentEntries+=PersistentEntry*)?)
	 */
	protected void sequence_KIdentifier(ISerializationContext context, KIdentifier semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Output returns LocalOutput
	 *     LocalOutput returns LocalOutput
	 *
	 * Constraint:
	 *     path=STRING
	 */
	protected void sequence_LocalOutput(ISerializationContext context, LocalOutput semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.LOCAL_OUTPUT__PATH) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.LOCAL_OUTPUT__PATH));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getLocalOutputAccess().getPathSTRINGTerminalRuleCall_0(), semanticObject.getPath());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Resource returns LocalResource
	 *     LocalResource returns LocalResource
	 *
	 * Constraint:
	 *     (path=STRING filter=STRING)
	 */
	protected void sequence_LocalResource(ISerializationContext context, LocalResource semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.LOCAL_RESOURCE__PATH) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.LOCAL_RESOURCE__PATH));
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.LOCAL_RESOURCE__FILTER) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.LOCAL_RESOURCE__FILTER));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getLocalResourceAccess().getPathSTRINGTerminalRuleCall_0_0(), semanticObject.getPath());
		feeder.accept(grammarAccess.getLocalResourceAccess().getFilterSTRINGTerminalRuleCall_1_1_0(), semanticObject.getFilter());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Output returns OutputReference
	 *     OutputReference returns OutputReference
	 *
	 * Constraint:
	 *     outputRef=[GlobalOutputRef|ID]
	 */
	protected void sequence_OutputReference(ISerializationContext context, OutputReference semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, GranaPackage.Literals.OUTPUT_REFERENCE__OUTPUT_REF) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, GranaPackage.Literals.OUTPUT_REFERENCE__OUTPUT_REF));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getOutputReferenceAccess().getOutputRefGlobalOutputRefIDTerminalRuleCall_1_0_1(), semanticObject.getOutputRef());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     PersistentEntry returns PersistentEntry
	 *
	 * Constraint:
	 *     (key=QualifiedID value=PropertyValue)
	 */
	protected void sequence_PersistentEntry(ISerializationContext context, PersistentEntry semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, KGraphPackage.Literals.PERSISTENT_ENTRY__KEY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, KGraphPackage.Literals.PERSISTENT_ENTRY__KEY));
			if (transientValues.isValueTransient(semanticObject, KGraphPackage.Literals.PERSISTENT_ENTRY__VALUE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, KGraphPackage.Literals.PERSISTENT_ENTRY__VALUE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getPersistentEntryAccess().getKeyQualifiedIDParserRuleCall_0_0(), semanticObject.getKey());
		feeder.accept(grammarAccess.getPersistentEntryAccess().getValuePropertyValueParserRuleCall_2_0(), semanticObject.getValue());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Job returns RangeJob
	 *     RangeJob returns RangeJob
	 *
	 * Constraint:
	 *     (
	 *         name=ID 
	 *         resources+=Resource+ 
	 *         layoutOptions+=KIdentifier+ 
	 *         analyses+=Analysis+ 
	 *         rangeOption=QualifiedID 
	 *         rangeValues=Range 
	 *         rangeAnalysis=Analysis 
	 *         rangeAnalysisComponent=NATURAL? 
	 *         output=Output
	 *     )
	 */
	protected void sequence_RangeJob(ISerializationContext context, RangeJob semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Job returns RegularJob
	 *     RegularJob returns RegularJob
	 *
	 * Constraint:
	 *     (
	 *         name=ID 
	 *         layoutBeforeAnalysis?='layoutBeforeAnalysis'? 
	 *         measureExecutionTime?='measureExecutionTime'? 
	 *         resources+=Resource+ 
	 *         layoutOptions+=KIdentifier+ 
	 *         analyses+=Analysis+ 
	 *         output=Output
	 *     )
	 */
	protected void sequence_RegularJob(ISerializationContext context, RegularJob semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Resource returns ResourceReference
	 *     ResourceReference returns ResourceReference
	 *
	 * Constraint:
	 *     resourceRefs+=[GlobalResourceRef|ID]+
	 */
	protected void sequence_ResourceReference(ISerializationContext context, ResourceReference semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
