package de.cau.cs.kieler.klighd.examples.dependencies;

import com.google.common.base.Objects;
import com.google.common.collect.Lists;
import com.google.inject.Guice;
import com.google.inject.Inject;
import com.google.inject.Injector;
import de.cau.cs.kieler.klighd.IAction;
import de.cau.cs.kieler.klighd.krendering.KColor;
import de.cau.cs.kieler.klighd.krendering.KPolyline;
import de.cau.cs.kieler.klighd.krendering.KRendering;
import de.cau.cs.kieler.klighd.krendering.extensions.KColorExtensions;
import de.cau.cs.kieler.klighd.krendering.extensions.KRenderingExtensions;
import java.util.List;
import java.util.function.Consumer;
import org.eclipse.elk.graph.KEdge;
import org.eclipse.elk.graph.KNode;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtext.xbase.lib.Extension;

@SuppressWarnings("all")
public class HighlightEdgesAction implements IAction {
  @Inject
  @Extension
  private KRenderingExtensions _kRenderingExtensions;
  
  @Inject
  @Extension
  private KColorExtensions _kColorExtensions;
  
  private final List<KPolyline> lastRunEdges = Lists.<KPolyline>newLinkedList();
  
  private KNode lastNode = null;
  
  public HighlightEdgesAction() {
    Injector _createInjector = Guice.createInjector();
    _createInjector.injectMembers(this);
  }
  
  @Override
  public IAction.ActionResult execute(final IAction.ActionContext context) {
    final Consumer<KPolyline> _function = new Consumer<KPolyline>() {
      @Override
      public void accept(final KPolyline e) {
        KColor _color = HighlightEdgesAction.this._kColorExtensions.getColor("black");
        HighlightEdgesAction.this._kRenderingExtensions.setForeground(e, _color);
        HighlightEdgesAction.this._kRenderingExtensions.setLineWidth(e, 1f);
      }
    };
    this.lastRunEdges.forEach(_function);
    this.lastRunEdges.clear();
    KNode _kNode = context.getKNode();
    boolean _equals = Objects.equal(this.lastNode, _kNode);
    if (_equals) {
      this.lastNode = null;
      return IAction.ActionResult.createResult(true);
    }
    KNode _kNode_1 = context.getKNode();
    this.lastNode = _kNode_1;
    KNode _kNode_2 = context.getKNode();
    EList<KEdge> _outgoingEdges = _kNode_2.getOutgoingEdges();
    final Consumer<KEdge> _function_1 = new Consumer<KEdge>() {
      @Override
      public void accept(final KEdge e) {
        final KRendering r = HighlightEdgesAction.this.getRendering(e);
        if ((r instanceof KPolyline)) {
          HighlightEdgesAction.this.highlight(r);
          HighlightEdgesAction.this.lastRunEdges.add(((KPolyline) r));
        }
      }
    };
    _outgoingEdges.forEach(_function_1);
    KNode _kNode_3 = context.getKNode();
    EList<KEdge> _incomingEdges = _kNode_3.getIncomingEdges();
    final Consumer<KEdge> _function_2 = new Consumer<KEdge>() {
      @Override
      public void accept(final KEdge e) {
        final KRendering r = HighlightEdgesAction.this.getRendering(e);
        if ((r instanceof KPolyline)) {
          HighlightEdgesAction.this.highlight(r);
          HighlightEdgesAction.this.lastRunEdges.add(((KPolyline) r));
        }
      }
    };
    _incomingEdges.forEach(_function_2);
    return IAction.ActionResult.createResult(true);
  }
  
  public KRendering highlight(final KRendering pl) {
    KRendering _xblockexpression = null;
    {
      KColor _color = this._kColorExtensions.getColor("red");
      this._kRenderingExtensions.setForeground(pl, _color);
      _xblockexpression = this._kRenderingExtensions.setLineWidth(pl, 3f);
    }
    return _xblockexpression;
  }
  
  public KRendering getRendering(final KEdge node) {
    return node.<KRendering>getData(KRendering.class);
  }
}
